/*
 * Intel ACPI Component Architecture
 * AML Disassembler version 20090123
 *
 * Disassembly of SSDT5.dat, Tue May 27 22:00:16 2014
 *
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x000004AB (1195)
 *     Revision         0x01
 *     Checksum         0x5E
 *     OEM ID           "COMPAL"
 *     OEM Table ID     "CRV ORB "
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "ACPI"
 *     Compiler Version 0x00040000 (262144)
 */
DefinitionBlock ("SSDT5.aml", "SSDT", 1, "COMPAL", "CRV ORB ", 0x00001000)
{
    External (NPPD)
    External (DPID)
    External (PPIA)

    Device (TPM)
    {
        Name (_HID, EisaId ("PNP0C31"))
        Name (_CID, EisaId ("PNP0C31"))
        Name (_STR, Unicode ("TPM 1.2 Device"))
        Name (_CRS, ResourceTemplate ()
        {
            Memory32Fixed (ReadWrite,
                0xFED40000,         // Address Base
                0x00005000,         // Address Length
                )
        })
        OperationRegion (SSMI, SystemIO, 0xB2, One)
        Field (SSMI, ByteAcc, NoLock, Preserve)
        {
            SMID,   8
        }

        OperationRegion (TPMS, SystemMemory, 0x9AFBDF98, 0x0000000C)
        Field (TPMS, AnyAcc, NoLock, Preserve)
        {
            TPMM,   8, 
            TPCC,   8, 
            TPLC,   8, 
            TPLR,   32, 
            NOPP,   8, 
            NOPC,   8, 
            NOPM,   8, 
            TPMC,   8, 
            UCTC,   8
        }

        OperationRegion (TPMR, SystemMemory, 0xFED40000, 0x5000)
        Field (TPMR, AnyAcc, NoLock, Preserve)
        {
            ACC0,   8
        }

        Method (_STA, 0, NotSerialized)
        {
            If (LEqual (ACC0, 0xFF))
            {
                Return (Zero)
            }

            Return (0x0F)
        }

        Method (HINF, 3, Serialized)
        {
            Name (_T_0, Zero)
            While (One)
            {
                Store (Arg1, _T_0)
                If (LEqual (_T_0, Zero))
                {
                    Return (Buffer (One)
                    {
                        0x01
                    })
                }
                Else
                {
                    If (LEqual (_T_0, One))
                    {
                        If (LEqual (_STA (), Zero))
                        {
                            Return (Package (0x01)
                            {
                                Zero
                            })
                        }

                        Return (Package (0x02)
                        {
                            One, 
                            Package (0x02)
                            {
                                One, 
                                0x20
                            }
                        })
                    }
                    Else
                    {
                        BreakPoint
                    }
                }

                Break
            }

            Return (Buffer (Zero) {})
        }

        Method (TPPI, 3, Serialized)
        {
            Name (_T_1, Zero)
            Name (_T_0, Zero)
            While (One)
            {
                Store (Arg1, _T_0)
                If (LEqual (_T_0, Zero))
                {
                    Return (Buffer (0x02)
                    {
                        0xFF, 0x01
                    })
                }
                Else
                {
                    If (LEqual (_T_0, One))
                    {
                        Return ("1.2")
                    }
                    Else
                    {
                        If (LEqual (_T_0, 0x02))
                        {
                            CreateByteField (Arg2, Zero, TPC1)
                            Or (TPC1, 0x80, TPCC)
                            If (LEqual (PPIA, Zero))
                            {
                                Return (0x02)
                            }

                            If (LGreater (TPC1, 0x11))
                            {
                                Return (One)
                            }

                            While (One)
                            {
                                Store (TPC1, _T_1)
                                If (LNotEqual (Match (Package (0x06)
                                                {
                                                    0x0C, 
                                                    0x0D, 
                                                    0x11, 
                                                    0x12, 
                                                    0x13, 
                                                    0x14
                                                }, MEQ, _T_1, MTR, Zero, Zero), Ones))
                                {
                                    Return (One)
                                }
                                Else
                                {
                                    If (LEqual (_T_1, 0x0F))
                                    {
                                        Store (Zero, DPID)
                                        Store (Zero, NPPD)
                                        Store (0xDD, SMID)
                                        Store (One, DPID)
                                        Store (Zero, NPPD)
                                        Store (0xDD, SMID)
                                    }
                                    Else
                                    {
                                        If (LEqual (_T_1, 0x10))
                                        {
                                            Store (Zero, DPID)
                                            Store (One, NPPD)
                                            Store (0xDD, SMID)
                                            Store (One, DPID)
                                            Store (One, NPPD)
                                            Store (0xDD, SMID)
                                        }
                                    }
                                }

                                Break
                            }

                            Store (0x50, SMID)
                            Return (Zero)
                        }
                        Else
                        {
                            If (LEqual (_T_0, 0x03))
                            {
                                Name (TCCP, Package (0x02)
                                {
                                    Zero, 
                                    0xFF
                                })
                                If (LEqual (PPIA, Zero))
                                {
                                    Return (One)
                                }

                                Store (TPCC, Index (TCCP, One))
                                Return (TCCP)
                            }
                            Else
                            {
                                If (LEqual (_T_0, 0x04))
                                {
                                    If (LEqual (PPIA, Zero))
                                    {
                                        Return (Zero)
                                    }

                                    If (LEqual (TPCC, 0x0F))
                                    {
                                        Return (Zero)
                                    }

                                    If (LEqual (TPCC, 0x10))
                                    {
                                        Return (0x02)
                                    }

                                    Return (0x02)
                                }
                                Else
                                {
                                    If (LEqual (_T_0, 0x05))
                                    {
                                        Name (TLCR, Package (0x03)
                                        {
                                            Zero, 
                                            0xFF, 
                                            Ones
                                        })
                                        If (LEqual (PPIA, Zero))
                                        {
                                            Store (One, Index (TLCR, Zero))
                                            Store (Zero, Index (TLCR, One))
                                            Store (Zero, Index (TLCR, 0x02))
                                            Return (TLCR)
                                        }

                                        Store (TPLC, Index (TLCR, One))
                                        Store (TPLR, Index (TLCR, 0x02))
                                        Return (TLCR)
                                    }
                                    Else
                                    {
                                        If (LEqual (_T_0, 0x06))
                                        {
                                            Return (0x03)
                                        }
                                        Else
                                        {
                                            If (LEqual (_T_0, 0x07))
                                            {
                                                Store (DerefOf (Index (Arg2, Zero)), Local0)
                                                If (LEqual (PPIA, Zero))
                                                {
                                                    Return (0x03)
                                                }

                                                If (LGreater (Local0, 0x0F))
                                                {
                                                    Store (Zero, DPID)
                                                    Store (Zero, NPPD)
                                                    Store (0xDD, SMID)
                                                    Store (One, DPID)
                                                    Store (Zero, NPPD)
                                                    Store (0xDD, SMID)
                                                }
                                                Else
                                                {
                                                    If (LGreater (Local0, 0x10))
                                                    {
                                                        Store (Zero, DPID)
                                                        Store (One, NPPD)
                                                        Store (0xDD, SMID)
                                                        Store (One, DPID)
                                                        Store (One, NPPD)
                                                        Store (0xDD, SMID)
                                                    }
                                                }

                                                Or (Local0, 0x80, TPCC)
                                                Store (0x50, SMID)
                                                Return (Zero)
                                            }
                                            Else
                                            {
                                                If (LEqual (_T_0, 0x08))
                                                {
                                                    If (LEqual (PPIA, Zero))
                                                    {
                                                        Return (0x02)
                                                    }

                                                    Store (DerefOf (Index (Arg2, Zero)), Local0)
                                                    Or (Local0, 0x80, TPMC)
                                                    Store (0x49, SMID)
                                                    Return (UCTC)
                                                }
                                                Else
                                                {
                                                    BreakPoint
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }

                Break
            }

            Return (One)
        }

        Method (SMOR, 3, Serialized)
        {
            Name (_T_0, Zero)
            While (One)
            {
                Store (Arg1, _T_0)
                If (LEqual (_T_0, Zero))
                {
                    Return (Buffer (One)
                    {
                        0x03
                    })
                }
                Else
                {
                    If (LEqual (_T_0, One))
                    {
                        Store (DerefOf (Index (Arg2, Zero)), TPMM)
                        Store (0x48, SMID)
                        Return (Zero)
                    }
                    Else
                    {
                        BreakPoint
                    }
                }

                Break
            }

            Return (One)
        }

        Method (_DSM, 4, NotSerialized)
        {
            If (LEqual (Arg0, Buffer (0x10)
                    {
                        /* 0000 */    0xA5, 0x16, 0x8E, 0xCF, 0xE8, 0xC1, 0x25, 0x4E, 
                        /* 0008 */    0xB7, 0x12, 0x4F, 0x54, 0xA9, 0x67, 0x02, 0xC8
                    }))
            {
                Return (HINF (Arg1, Arg2, Arg3))
            }

            If (LEqual (Arg0, Buffer (0x10)
                    {
                        /* 0000 */    0xA6, 0xFA, 0xDD, 0x3D, 0x1B, 0x36, 0xB4, 0x4E, 
                        /* 0008 */    0xA4, 0x24, 0x8D, 0x10, 0x08, 0x9D, 0x16, 0x53
                    }))
            {
                Return (TPPI (Arg1, Arg2, Arg3))
            }

            If (LEqual (Arg0, Buffer (0x10)
                    {
                        /* 0000 */    0xED, 0x54, 0x60, 0x37, 0x13, 0xCC, 0x75, 0x46, 
                        /* 0008 */    0x90, 0x1C, 0x47, 0x56, 0xD7, 0xF2, 0xD4, 0x5D
                    }))
            {
                Return (SMOR (Arg1, Arg2, Arg3))
            }

            Return (Buffer (Zero) {})
        }
    }
}

